package labthree;

import javax.vecmath.Point2d;
import java.awt.*;
import java.awt.geom.Point2D;

/**
 * Created by IntelliJ IDEA.
 * User: zaic
 */
public class Bresenham {
    public static void drawLine(int field[][], int xfrom, int yfrom, int xto, int yto, boolean inverted) {
        //System.err.println("line: (" + xfrom + ", " + yfrom + ") - (" + xto + ", " + yto + ")");
        final int field_height = field.length;
        final int field_width  = field[0].length;

        int dx = Math.abs(xto - xfrom);
        int dy = Math.abs(yto - yfrom);

        if(dy > dx) {
            drawLine(field, -yfrom, xfrom, -yto, xto, !inverted);
            return ;
        }

        if(xto < xfrom) {
            drawLine(field, xto, yto, xfrom, yfrom, inverted);
            return ;
        }

        int direction = (yto > yfrom ? 1 : -1);
        for(int i = xfrom; i <= xto; i++) {
            double currentY = (i - xfrom) / (double)dx * dy;
            int add = (int)(currentY + .5);
            int x = inverted ? yfrom + add * direction : i;
            int y = inverted ? -i : yfrom + add * direction;
            if(0 <= y && y < field_height && 0 <= x && x <= field_width)
                field[y][x] = 0;
        }
    }

    public static void drawLine(int field[][], int xfrom, int yfrom, int xto, int yto) {
        drawLine(field, xfrom, yfrom, xto, yto, false);
    }

    public static void drawLine(Graphics2D g, PlotPanel panel, int xfrom, int yfrom, int xto, int yto, boolean inverted) {
        //System.err.println("line: (" + xfrom + ", " + yfrom + ") - (" + xto + ", " + yto + ")");
        int dx = Math.abs(xto - xfrom);
        int dy = Math.abs(yto - yfrom);

        if(dy > dx) {
            drawLine(g, panel, -yfrom, xfrom, -yto, xto, !inverted);
            return ;
        }

        if(xto < xfrom) {
            drawLine(g, panel, xto, yto, xfrom, yfrom, inverted);
            return ;
        }

        int direction = (yto > yfrom ? 1 : -1);
        for(int i = xfrom; i <= xto; i++) {
            double currentY = (i - xfrom) / (double)dx * dy;
            int add = (int)(currentY + .5);
            int x = inverted ? yfrom + add * direction : i;
            int y = inverted ? -i : yfrom + add * direction;
            panel.drawPixel(g, x, y);
        }
    }

    public static void drawLine(Graphics2D g, PlotPanel panel, int xfrom, int yfrom, int xto, int yto) {
        drawLine(g, panel, xfrom, yfrom, xto, yto, false);
    }
    
    public static void drawLine(Graphics2D g, PlotPanel panel, Point2d from, Point2d to) {
        drawLine(g, panel, (int)(from.x + .5), (int)(from.y + .5), (int)(to.x + .5), (int)(to.y + .5));
    }
}
