package labthree;

import javax.swing.*;
import javax.vecmath.Point2d;
import javax.vecmath.Point3d;
import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: zaic
 */
public class PlotPanel extends JPanel {

    PlotPanel() {
        super();
    }

    /*
        pixel
    */
    void drawRealPixel(Graphics2D g, int x, int y) {
        int realX = x + getWidth() / 2;
        int realY = getHeight() / 2 - y;
        if(0 <= realX && realX <= getWidth() && 0 <= realY && realY <= getHeight()) {
            g.drawLine(realX, realY, realX, realY);
        }
    }

    void drawPixel(Graphics2D g, double x, double y) {
        int real_x = (int)(x);
        int real_y = (int)(y);
        drawRealPixel(g, real_x, real_y);
    }

    void drawPixel(Graphics2D g, double x, double y, Color color) {
        Color prev_color = g.getColor();
        g.setColor(color);
        drawPixel(g, x, y);
        g.setColor(prev_color);
    }

    /*
        axes
     */
    void drawAxe(Graphics2D g, Color color, int x, int y, int z) {
        Point2d prev_point = null;
        Color prev_color = g.getColor();
        g.setColor(color);
        for(double t = 0.0; t < 100; t += 0.05) {
            try {
                Point3d next_point3d = new Point3d(x * t, y * t, z * t);
                Point2d next_point = Projection.go(next_point3d);
                //drawPixel(g, next_point.x, next_point.y);
                if(prev_point != null) {
                    Bresenham.drawLine(g, this, prev_point, next_point);
                }
                prev_point = next_point;
            } catch(IntersectException e) {
                prev_point = null;
            }
        }
        g.setColor(color);
    }
    
    void drawAxes(Graphics2D g) {
        drawAxe(g, Color.GREEN, 1, 0, 0);
        drawAxe(g, Color.BLUE,  0, 1, 0);
        drawAxe(g, Color.RED,   0, 0, 1);
    }

    /*
        repaint
     */
    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        setBackground(Color.white);
        Graphics2D g2 = (Graphics2D) g;
        g2.setStroke(new BasicStroke(2.0f));
        g2.setColor(Color.black);
        drawAxes(g2);
        /*
        Projection.go(new Point3d(0, 0, 0));
        Projection.go(new Point3d(1, 0, 0));
        Projection.go(new Point3d(0, 1, 0));
        Projection.go(new Point3d(0, 0, 1));
        Projection.go(new Point3d(1, 1, 1));
        */
        SplineBezier.draw(g2, this);
    }

}
